diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/interference-helper.cc ns-3.46/src/wifi/model/interference-helper.cc
--- ns-3.45/src/wifi/model/interference-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/interference-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -10,6 +10,7 @@
 #include "interference-helper.h"
 
 #include "error-rate-model.h"
+#include "phy-entity.h"
 #include "wifi-phy-operating-channel.h"
 #include "wifi-phy.h"
 #include "wifi-psdu.h"
@@ -134,11 +135,6 @@
 {
 }
 
-InterferenceHelper::NiChange::~NiChange()
-{
-    m_event = nullptr;
-}
-
 Watt_u
 InterferenceHelper::NiChange::GetPower() const
 {
@@ -471,14 +467,13 @@
     {
         ;
     }
-    NiChanges ni;
+    auto& ni = nis[band];
     ni.emplace(event->GetStartTime(), NiChange(Watt_u{0}, event));
     while (++it != niIt->second.end() && it->second.GetEvent() != event)
     {
         ni.insert(*it);
     }
     ni.emplace(event->GetEndTime(), NiChange(Watt_u{0}, event));
-    nis.insert({band, ni});
     NS_ASSERT_MSG(noiseInterference >= Watt_u{0.0},
                   "CalculateNoiseInterferenceW returns negative value " << noiseInterference);
     return noiseInterference;
@@ -646,12 +641,11 @@
 }
 
 double
-InterferenceHelper::CalculatePhyHeaderSectionPsr(
-    Ptr<const Event> event,
-    NiChangesPerBand* nis,
-    MHz_u channelWidth,
-    const WifiSpectrumBandInfo& band,
-    PhyEntity::PhyHeaderSections phyHeaderSections) const
+InterferenceHelper::CalculatePhyHeaderSectionPsr(Ptr<const Event> event,
+                                                 NiChangesPerBand* nis,
+                                                 MHz_u channelWidth,
+                                                 const WifiSpectrumBandInfo& band,
+                                                 PhyHeaderSections phyHeaderSections) const
 {
     NS_LOG_FUNCTION(this << band);
     double psr = 1.0; /* Packet Success Rate */
@@ -721,7 +715,7 @@
     auto phyEntity =
         WifiPhy::GetStaticPhyEntity(event->GetPpdu()->GetTxVector().GetModulationClass());
 
-    PhyEntity::PhyHeaderSections sections;
+    PhyHeaderSections sections;
     for (const auto& section :
          phyEntity->GetPhyHeaderSections(event->GetPpdu()->GetTxVector(), niIt.begin()->first))
     {
@@ -739,7 +733,7 @@
     return 1 - psr;
 }
 
-PhyEntity::SnrPer
+SnrPer
 InterferenceHelper::CalculatePayloadSnrPer(Ptr<Event> event,
                                            MHz_u channelWidth,
                                            const WifiSpectrumBandInfo& band,
@@ -761,7 +755,7 @@
     const auto per =
         CalculatePayloadPer(event, channelWidth, &ni, band, staId, relativeMpduStartStop);
 
-    return PhyEntity::SnrPer(snr, per);
+    return SnrPer(snr, per);
 }
 
 double
@@ -775,7 +769,7 @@
     return CalculateSnr(event->GetRxPower(band), noiseInterference, channelWidth, nss);
 }
 
-PhyEntity::SnrPer
+SnrPer
 InterferenceHelper::CalculatePhyHeaderSnrPer(Ptr<Event> event,
                                              MHz_u channelWidth,
                                              const WifiSpectrumBandInfo& band,
@@ -791,7 +785,7 @@
      */
     const auto per = CalculatePhyHeaderPer(event, &ni, channelWidth, band, header);
 
-    return PhyEntity::SnrPer(snr, per);
+    return SnrPer(snr, per);
 }
 
 InterferenceHelper::NiChanges::iterator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/interference-helper.h ns-3.46/src/wifi/model/interference-helper.h
--- ns-3.45/src/wifi/model/interference-helper.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/interference-helper.h	2025-10-01 18:46:32.000000000 -0700
@@ -9,10 +9,14 @@
 #ifndef INTERFERENCE_HELPER_H
 #define INTERFERENCE_HELPER_H
 
-#include "phy-entity.h"
+#include "wifi-phy-common.h"
+#include "wifi-ppdu.h"
+#include "wifi-tx-vector.h"
 
 #include "ns3/object.h"
 
+#include <map>
+
 namespace ns3
 {
 
@@ -21,6 +25,11 @@
 class ErrorRateModel;
 
 /**
+ * A map of the received power for each band
+ */
+using RxPowerWattPerChannelBand = std::map<WifiSpectrumBandInfo, Watt_u>;
+
+/**
  * @ingroup wifi
  * @brief handles interference calculations
  * @brief signal event for a PPDU.
@@ -241,11 +250,11 @@
      *
      * @return struct of SNR and PER (with PER being evaluated over the provided time window)
      */
-    PhyEntity::SnrPer CalculatePayloadSnrPer(Ptr<Event> event,
-                                             MHz_u channelWidth,
-                                             const WifiSpectrumBandInfo& band,
-                                             uint16_t staId,
-                                             std::pair<Time, Time> relativeMpduStartStop) const;
+    SnrPer CalculatePayloadSnrPer(Ptr<Event> event,
+                                  MHz_u channelWidth,
+                                  const WifiSpectrumBandInfo& band,
+                                  uint16_t staId,
+                                  std::pair<Time, Time> relativeMpduStartStop) const;
     /**
      * Calculate the SNIR for the event (starting from now until the event end).
      *
@@ -271,10 +280,10 @@
      *
      * @return struct of SNR and PER
      */
-    PhyEntity::SnrPer CalculatePhyHeaderSnrPer(Ptr<Event> event,
-                                               MHz_u channelWidth,
-                                               const WifiSpectrumBandInfo& band,
-                                               WifiPpduField header) const;
+    SnrPer CalculatePhyHeaderSnrPer(Ptr<Event> event,
+                                    MHz_u channelWidth,
+                                    const WifiSpectrumBandInfo& band,
+                                    WifiPpduField header) const;
 
     /**
      * Notify that RX has started.
@@ -365,7 +374,7 @@
          * @param event causes this NI change
          */
         NiChange(Watt_u power, Ptr<Event> event);
-        ~NiChange();
+
         /**
          * Return the power
          *
@@ -505,7 +514,7 @@
      * @param nis the NiChanges
      * @param channelWidth the channel width for header measurement
      * @param band the band
-     * @param phyHeaderSections the map of PHY header sections (\see PhyEntity::PhyHeaderSections)
+     * @param phyHeaderSections the map of PHY header sections (\see PhyHeaderSections)
      *
      * @return the success rate of the PHY header sections
      */
@@ -513,7 +522,7 @@
                                         NiChangesPerBand* nis,
                                         MHz_u channelWidth,
                                         const WifiSpectrumBandInfo& band,
-                                        PhyEntity::PhyHeaderSections phyHeaderSections) const;
+                                        PhyHeaderSections phyHeaderSections) const;
 
     double m_noiseFigure;                 //!< noise figure (linear)
     Ptr<ErrorRateModel> m_errorRateModel; //!< error rate model
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/mgt-action-headers.cc ns-3.46/src/wifi/model/mgt-action-headers.cc
--- ns-3.45/src/wifi/model/mgt-action-headers.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/mgt-action-headers.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1641,6 +1641,7 @@
     }
     if (m_frameCtl.m_capPresenceInd)
     {
+        m_fdCap = FilsDiscHeader::FdCapability{};
         nOctets = m_fdCap->Deserialize(i);
         i.Next(nOctets);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/non-ht/dsss-phy.cc ns-3.46/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.45/src/wifi/model/non-ht/dsss-phy.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/non-ht/dsss-phy.cc	2025-10-01 18:46:32.000000000 -0700
@@ -404,7 +404,7 @@
     ConstructorDsss()
     {
         ns3::DsssPhy::InitializeModes();
-        ns3::Ptr<ns3::DsssPhy> phyEntity = ns3::Create<ns3::DsssPhy>();
+        auto phyEntity = std::make_shared<ns3::DsssPhy>();
         ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_HR_DSSS, phyEntity);
         ns3::WifiPhy::AddStaticPhyEntity(
             ns3::WIFI_MOD_CLASS_DSSS,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.46/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.45/src/wifi/model/non-ht/erp-ofdm-phy.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/non-ht/erp-ofdm-phy.cc	2025-10-01 18:46:32.000000000 -0700
@@ -252,7 +252,7 @@
     {
         ns3::ErpOfdmPhy::InitializeModes();
         ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_ERP_OFDM,
-                                         ns3::Create<ns3::ErpOfdmPhy>());
+                                         std::make_shared<ns3::ErpOfdmPhy>());
     }
 } g_constructor_erp_ofdm; ///< the constructor for ERP-OFDM modes
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/non-ht/ofdm-phy.cc ns-3.46/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.45/src/wifi/model/non-ht/ofdm-phy.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/non-ht/ofdm-phy.cc	2025-10-01 18:46:32.000000000 -0700
@@ -709,8 +709,9 @@
     ConstructorOfdm()
     {
         ns3::OfdmPhy::InitializeModes();
-        ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_OFDM,
-                                         ns3::Create<ns3::OfdmPhy>()); // default variant will do
+        ns3::WifiPhy::AddStaticPhyEntity(
+            ns3::WIFI_MOD_CLASS_OFDM,
+            std::make_shared<ns3::OfdmPhy>()); // default variant will do
     }
 } g_constructor_ofdm; ///< the constructor for OFDM modes
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/phy-entity.cc ns-3.46/src/wifi/model/phy-entity.cc
--- ns-3.45/src/wifi/model/phy-entity.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/phy-entity.cc	2025-10-01 18:46:32.000000000 -0700
@@ -15,13 +15,16 @@
 #include "interference-helper.h"
 #include "preamble-detection-model.h"
 #include "spectrum-wifi-phy.h"
+#include "wifi-net-device.h"
 #include "wifi-psdu.h"
+#include "wifi-radio-energy-model.h"
 #include "wifi-spectrum-signal-parameters.h"
 #include "wifi-utils.h"
 
 #include "ns3/assert.h"
 #include "ns3/data-rate.h"
 #include "ns3/log.h"
+#include "ns3/mobility-model.h"
 #include "ns3/packet.h"
 #include "ns3/simulator.h"
 
@@ -212,7 +215,7 @@
     return ppdu->GetPsdu();
 }
 
-PhyEntity::PhyHeaderSections
+PhyHeaderSections
 PhyEntity::GetPhyHeaderSections(const WifiTxVector& txVector, Time ppduStart) const
 {
     PhyHeaderSections map;
@@ -257,7 +260,7 @@
         .first; // return the start time of field relatively to the beginning of the PPDU
 }
 
-PhyEntity::SnrPer
+SnrPer
 PhyEntity::GetPhyHeaderSnrPer(WifiPpduField field, Ptr<Event> event) const
 {
     const auto measurementChannelWidth = GetMeasurementChannelWidth(event->GetPpdu());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/phy-entity.h ns-3.46/src/wifi/model/phy-entity.h
--- ns-3.45/src/wifi/model/phy-entity.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/phy-entity.h	2025-10-01 18:46:32.000000000 -0700
@@ -13,6 +13,8 @@
 #define PHY_ENTITY_H
 
 #include "wifi-phy-band.h"
+#include "wifi-phy-state-helper.h"
+#include "wifi-phy.h"
 #include "wifi-ppdu.h"
 #include "wifi-tx-vector.h"
 #include "wifi-types.h"
@@ -20,6 +22,7 @@
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/simple-ref-count.h"
+#include "ns3/wifi-export.h"
 
 #include <list>
 #include <map>
@@ -60,7 +63,7 @@
  * to be used by each PHY entity, corresponding to
  * the different amendments of the IEEE 802.11 standard.
  */
-class PhyEntity : public SimpleRefCount<PhyEntity>
+class WIFI_EXPORT PhyEntity
 {
   public:
     /**
@@ -109,34 +112,6 @@
     };
 
     /**
-     * A struct for both SNR and PER
-     */
-    struct SnrPer
-    {
-        double snr{0.0}; ///< SNR in linear scale
-        double per{1.0}; ///< PER
-
-        /**
-         * Default constructor.
-         */
-        SnrPer()
-        {
-        }
-
-        /**
-         * Constructor for SnrPer.
-         *
-         * @param s the SNR in linear scale
-         * @param p the PER
-         */
-        SnrPer(double s, double p)
-            : snr(s),
-              per(p)
-        {
-        }
-    };
-
-    /**
      * Destructor for PHY entity
      */
     virtual ~PhyEntity();
@@ -283,16 +258,6 @@
     virtual uint32_t GetMaxPsduSize() const = 0;
 
     /**
-     * A pair containing information on the PHY header chunk, namely
-     * the start and stop times of the chunk and the WifiMode used.
-     */
-    typedef std::pair<std::pair<Time /* start */, Time /* stop */>, WifiMode> PhyHeaderChunkInfo;
-    /**
-     * A map of PhyHeaderChunkInfo elements per PPDU field.
-     * @see PhyHeaderChunkInfo
-     */
-    typedef std::map<WifiPpduField, PhyHeaderChunkInfo> PhyHeaderSections;
-    /**
      * Return a map of PHY header chunk information per PPDU field.
      * This map will contain the PPDU fields that are actually present based
      * on the \p txVector information.
@@ -716,7 +681,7 @@
                                     uint16_t staId,
                                     const std::vector<bool>& statusPerMpdu);
     /**
-     * Perform amendment-specific actions when the payload is unsuccessfuly received.
+     * Perform amendment-specific actions when the payload is unsuccessfully received.
      *
      * @param psdu the PSDU that we failed to received
      * @param snr the SNR of the received PSDU in linear scale
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/qos-txop.cc ns-3.46/src/wifi/model/qos-txop.cc
--- ns-3.45/src/wifi/model/qos-txop.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/qos-txop.cc	2025-10-01 18:46:32.000000000 -0700
@@ -177,7 +177,7 @@
 uint8_t
 QosTxop::GetQosQueueSize(uint8_t tid, Mac48Address receiver) const
 {
-    WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, receiver, tid};
+    WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, receiver, tid};
     uint32_t bufferSize = m_queue->GetNBytes(queueId);
     // A queue size value of 254 is used for all sizes greater than 64 768 octets.
     uint8_t queueSize = static_cast<uint8_t>(std::ceil(std::min(bufferSize, 64769U) / 256.0));
@@ -393,7 +393,8 @@
             return m_queue->PeekFirstAvailable(linkId, mpdu);
         }
         WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE,
-                                     recipient.IsGroup() ? WIFI_GROUPCAST : WIFI_UNICAST,
+                                     recipient.IsGroup() ? WifiRcvAddr::GROUPCAST
+                                                         : WifiRcvAddr::UNICAST,
                                      recipient,
                                      tid);
         if (auto mask = m_mac->GetMacQueueScheduler()->GetQueueLinkMask(m_ac, queueId, linkId);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/qos-utils.h ns-3.46/src/wifi/model/qos-utils.h
--- ns-3.45/src/wifi/model/qos-utils.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/qos-utils.h	2025-10-01 18:46:32.000000000 -0700
@@ -11,6 +11,7 @@
 
 #include "ns3/fatal-error.h"
 #include "ns3/ptr.h"
+#include "ns3/wifi-export.h"
 
 #include <map>
 
@@ -195,7 +196,7 @@
  * Map containing the four ACs in increasing order of priority (according to
  * Table 10-1 "UP-to-AC Mappings" of 802.11-2016)
  */
-extern const std::map<AcIndex, WifiAc> wifiAcList;
+WIFI_EXPORT extern const std::map<AcIndex, WifiAc> wifiAcList;
 
 /**
  * @ingroup wifi
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/sta-wifi-mac.cc ns-3.46/src/wifi/model/sta-wifi-mac.cc
--- ns-3.45/src/wifi/model/sta-wifi-mac.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/sta-wifi-mac.cc	2025-10-01 18:46:32.000000000 -0700
@@ -74,6 +74,12 @@
                           UintegerValue(10),
                           MakeUintegerAccessor(&StaWifiMac::m_maxMissedBeacons),
                           MakeUintegerChecker<uint32_t>())
+            .AddAttribute("EnableScanning",
+                          "If false, STA does not perform channel scanning. This may be useful in "
+                          "case of static configuration via the static setup helper.",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&StaWifiMac::m_enableScanning),
+                          MakeBooleanChecker())
             .AddAttribute(
                 "ActiveProbing",
                 "If true, we send probe requests. If false, we don't."
@@ -823,6 +829,11 @@
 StaWifiMac::StartScanning()
 {
     NS_LOG_FUNCTION(this);
+    if (!m_enableScanning)
+    {
+        NS_LOG_DEBUG("Scanning disabled");
+        return;
+    }
     SetState(SCANNING);
     NS_ASSERT(m_assocManager);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/sta-wifi-mac.h ns-3.46/src/wifi/model/sta-wifi-mac.h
--- ns-3.45/src/wifi/model/sta-wifi-mac.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/sta-wifi-mac.h	2025-10-01 18:46:32.000000000 -0700
@@ -148,6 +148,7 @@
     friend class ::AmpduAggregationTest;
     friend class ::MultiLinkOperationsTestBase;
     friend class ::ProbeExchTest;
+    friend class WifiStaticSetupHelper;
 
     /**
      * Struct to hold information regarding observed AP through
@@ -662,6 +663,7 @@
     uint32_t m_maxMissedBeacons;                  ///< maximum missed beacons
     EventId m_beaconWatchdog;                     //!< beacon watchdog
     Time m_beaconWatchdogEnd{0};                  //!< beacon watchdog end
+    bool m_enableScanning;                        //!< enable channel scanning
     bool m_activeProbing;                         ///< active probing
     Ptr<RandomVariableStream> m_probeDelay;       ///< RandomVariable used to randomize the time
                                                   ///< of the first Probe Response on each channel
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/tim.cc ns-3.46/src/wifi/model/tim.cc
--- ns-3.45/src/wifi/model/tim.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/tim.cc	2025-10-01 18:46:32.000000000 -0700
@@ -8,7 +8,7 @@
 
 #include "tim.h"
 
-#include "wifi-constants.h"
+#include "wifi-standard-constants.h"
 
 #include <algorithm>
 #include <cstdint>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/txop.cc ns-3.46/src/wifi/model/txop.cc
--- ns-3.45/src/wifi/model/txop.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/txop.cc	2025-10-01 18:46:32.000000000 -0700
@@ -65,18 +65,6 @@
                                           "AC_BEACON",
                                           AC_UNDEF,
                                           "AC_UNDEF"))
-            // NS_DEPRECATED_3_42
-            .AddAttribute(
-                "MinCw",
-                "The minimum value of the contention window (just for the first link, "
-                "in case of 11be multi-link devices).",
-                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                UintegerValue(15),
-                MakeUintegerAccessor(static_cast<void (Txop::*)(uint32_t)>(&Txop::SetMinCw),
-                                     static_cast<uint32_t (Txop::*)() const>(&Txop::GetMinCw)),
-                MakeUintegerChecker<uint32_t>(),
-                TypeId::SupportLevel::OBSOLETE,
-                "Use MinCws attribute instead of MinCw")
             .AddAttribute(
                 "MinCws",
                 "The minimum values of the contention window for all the links (sorted in "
@@ -87,18 +75,6 @@
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetMinCws, &Txop::GetMinCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
-            // NS_DEPRECATED_3_42
-            .AddAttribute(
-                "MaxCw",
-                "The maximum value of the contention window (just for the first link, "
-                "in case of 11be multi-link devices).",
-                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                UintegerValue(1023),
-                MakeUintegerAccessor(static_cast<void (Txop::*)(uint32_t)>(&Txop::SetMaxCw),
-                                     static_cast<uint32_t (Txop::*)() const>(&Txop::GetMaxCw)),
-                MakeUintegerChecker<uint32_t>(),
-                TypeId::SupportLevel::OBSOLETE,
-                "Use MaxCws attribute instead of MaxCw")
             .AddAttribute(
                 "MaxCws",
                 "The maximum values of the contention window for all the links (sorted in "
@@ -109,18 +85,6 @@
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetMaxCws, &Txop::GetMaxCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
-            // NS_DEPRECATED_3_42
-            .AddAttribute(
-                "Aifsn",
-                "The AIFSN: the default value conforms to non-QOS (just for the first link, "
-                "in case of 11be multi-link devices).",
-                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                UintegerValue(2),
-                MakeUintegerAccessor(static_cast<void (Txop::*)(uint8_t)>(&Txop::SetAifsn),
-                                     static_cast<uint8_t (Txop::*)() const>(&Txop::GetAifsn)),
-                MakeUintegerChecker<uint8_t>(),
-                TypeId::SupportLevel::OBSOLETE,
-                "Use Aifsns attribute instead of Aifsn")
             .AddAttribute(
                 "Aifsns",
                 "The values of AIFSN for all the links (sorted in increasing order "
@@ -131,18 +95,6 @@
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetAifsns, &Txop::GetAifsns),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()))
-            // NS_DEPRECATED_3_42
-            .AddAttribute(
-                "TxopLimit",
-                "The TXOP limit: the default value conforms to non-QoS "
-                "(just for the first link, in case of 11be multi-link devices).",
-                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                TimeValue(MilliSeconds(0)),
-                MakeTimeAccessor(static_cast<void (Txop::*)(Time)>(&Txop::SetTxopLimit),
-                                 static_cast<Time (Txop::*)() const>(&Txop::GetTxopLimit)),
-                MakeTimeChecker(),
-                TypeId::SupportLevel::OBSOLETE,
-                "Use TxopLimits attribute instead of TxopLimit")
             .AddAttribute(
                 "TxopLimits",
                 "The values of TXOP limit for all the links (sorted in increasing order "
@@ -810,10 +762,9 @@
 }
 
 void
-Txop::NotifyOff()
+Txop::NotifyOff(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this);
-    m_queue->Flush();
+    NS_LOG_FUNCTION(this << linkId);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/txop.h ns-3.46/src/wifi/model/txop.h
--- ns-3.45/src/wifi/model/txop.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/txop.h	2025-10-01 18:46:32.000000000 -0700
@@ -330,9 +330,11 @@
      */
     virtual void NotifySleep(uint8_t linkId);
     /**
-     * When off operation occurs, the queue gets cleaned up.
+     * Notify that the given link is switched off.
+     *
+     * @param linkId the ID of the given link
      */
-    virtual void NotifyOff();
+    virtual void NotifyOff(uint8_t linkId);
     /**
      * When wake up operation occurs on a link, channel access on that link
      * will be restarted.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/vht/vht-phy.cc ns-3.46/src/wifi/model/vht/vht-phy.cc
--- ns-3.45/src/wifi/model/vht/vht-phy.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/vht/vht-phy.cc	2025-10-01 18:46:32.000000000 -0700
@@ -583,7 +583,7 @@
     ConstructorVht()
     {
         ns3::VhtPhy::InitializeModes();
-        ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_VHT, ns3::Create<ns3::VhtPhy>());
+        ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_VHT, std::make_shared<ns3::VhtPhy>());
     }
 } g_constructor_vht; ///< the constructor for VHT modes
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-default-ack-manager.cc ns-3.46/src/wifi/model/wifi-default-ack-manager.cc
--- ns-3.45/src/wifi/model/wifi-default-ack-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-default-ack-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -152,7 +152,8 @@
     }
     // * no other frame belonging to this BA agreement is queued (because, in such
     //   a case, a Block Ack is not going to be requested anytime soon)
-    if (auto queueId = WifiContainerQueueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, origReceiver, tid);
+    if (auto queueId =
+            WifiContainerQueueId(WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, origReceiver, tid);
         edca->GetWifiMacQueue()->GetNPackets(queueId) -
             edca->GetBaManager()->GetNBufferedPackets(origReceiver, tid) - seqNumbers.size() <
         1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-mac.h ns-3.46/src/wifi/model/wifi-mac.h
--- ns-3.45/src/wifi/model/wifi-mac.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-mac.h	2025-10-01 18:46:32.000000000 -0700
@@ -89,6 +89,8 @@
 class WifiMac : public Object
 {
   public:
+    friend class WifiStaticSetupHelper;
+
     /**
      * @brief Get the type ID.
      * @return the object TypeId
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-mac-queue.cc ns-3.46/src/wifi/model/wifi-mac-queue.cc
--- ns-3.45/src/wifi/model/wifi-mac-queue.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-mac-queue.cc	2025-10-01 18:46:32.000000000 -0700
@@ -318,7 +318,7 @@
     NS_LOG_FUNCTION(this << +tid << dest << item);
     NS_ABORT_IF(dest.IsBroadcast());
     WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE,
-                                 dest.IsGroup() ? WIFI_GROUPCAST : WIFI_UNICAST,
+                                 dest.IsGroup() ? WifiRcvAddr::GROUPCAST : WifiRcvAddr::UNICAST,
                                  dest,
                                  tid);
     return PeekByQueueId(queueId, item);
@@ -387,7 +387,13 @@
 Ptr<WifiMpdu>
 WifiMacQueue::Remove()
 {
-    return Remove(Peek());
+    if (auto queueId = m_scheduler->GetNext(m_ac, std::nullopt, false))
+    {
+        return Remove(GetContainer().GetQueue(queueId.value()).cbegin()->mpdu);
+    }
+
+    NS_LOG_DEBUG("The queue is empty");
+    return nullptr;
 }
 
 Ptr<WifiMpdu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-mac-queue-container.cc ns-3.46/src/wifi/model/wifi-mac-queue-container.cc
--- ns-3.45/src/wifi/model/wifi-mac-queue-container.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-mac-queue-container.cc	2025-10-01 18:46:32.000000000 -0700
@@ -70,21 +70,21 @@
 {
     const WifiMacHeader& hdr = mpdu->GetHeader();
 
-    WifiReceiverAddressType addrType;
+    WifiRcvAddr addrType;
     Mac48Address address;
     if (hdr.GetAddr1().IsBroadcast())
     {
-        addrType = WIFI_BROADCAST;
+        addrType = WifiRcvAddr::BROADCAST;
         address = hdr.GetAddr2();
     }
     else if (hdr.GetAddr1().IsGroup())
     {
-        addrType = WIFI_GROUPCAST;
+        addrType = WifiRcvAddr::GROUPCAST;
         address = hdr.IsQosAmsdu() ? mpdu->begin()->second.GetDestinationAddr() : hdr.GetAddr1();
     }
     else
     {
-        addrType = WIFI_UNICAST;
+        addrType = WifiRcvAddr::UNICAST;
         address = hdr.GetAddr1();
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-mac-queue-container.h ns-3.46/src/wifi/model/wifi-mac-queue-container.h
--- ns-3.45/src/wifi/model/wifi-mac-queue-container.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-mac-queue-container.h	2025-10-01 18:46:32.000000000 -0700
@@ -11,6 +11,7 @@
 
 #include "wifi-mac-queue-elem.h"
 
+#include "ns3/deprecated.h"
 #include "ns3/mac48-address.h"
 
 #include <list>
@@ -30,15 +31,30 @@
     WIFI_DATA_QUEUE = 3
 };
 
-/// enumeration of frame directions
-enum WifiReceiverAddressType : uint8_t
+/// enumeration of frame types based on receiver address
+enum class WifiRcvAddr : uint8_t
 {
-    WIFI_UNICAST = 0,
-    WIFI_BROADCAST,
-    WIFI_GROUPCAST
+    UNICAST = 0,
+    BROADCAST,
+    GROUPCAST,
+    COUNT
 };
 
 /**
+ * Deprecated frame types enums.
+ *
+ * Use `WifiRcvAddr` class enum values instead.
+ * @{
+ */
+NS_DEPRECATED_3_46("Use WifiRcvAddr::UNICAST instead")
+static constexpr auto WIFI_UNICAST = WifiRcvAddr::UNICAST;
+NS_DEPRECATED_3_46("Use WifiRcvAddr::BROADCAST instead")
+static constexpr auto WIFI_BROADCAST = WifiRcvAddr::BROADCAST;
+NS_DEPRECATED_3_46("Use WifiRcvAddr::GROUPCAST instead")
+static constexpr auto WIFI_GROUPCAST = WifiRcvAddr::GROUPCAST;
+/**@}*/
+
+/**
  * Tuple (queue type, receiver address type, Address, TID) identifying a container queue.
  *
  * @note that Address has a different meaning depending on container queue type:
@@ -65,8 +81,8 @@
  *
  * The TID is only specified for container queue types holding QoS data frames.
  */
-using WifiContainerQueueId = std::
-    tuple<WifiContainerQueueType, WifiReceiverAddressType, Mac48Address, std::optional<uint8_t>>;
+using WifiContainerQueueId =
+    std::tuple<WifiContainerQueueType, WifiRcvAddr, Mac48Address, std::optional<uint8_t>>;
 
 } // namespace ns3
 
